<?php 
/**
 * @version: 	1.0 Alpha 3 2010-08-10
 * @package:    jPhone
 * @desc:    	jPhone ist eine Joomla Komponente die Inhalte fuer Mobilegeraete aufbereitet vorallem fuer das iPhone
 * @author: 	Urs Kobald
 * @author: 	http://www.4you-studio.com
 * @copyright:	Copyright (C) 2010 4you-Studio by Urs Kobald. All rights reserved. 
 * @license:	http://www.gnu.org/copyleft/gpl.html GNU/GPL 
*
 */





// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );





class jPhone
{





	/*
	 * Variablen
	 */
	private $params 		= null;
	
	private $setHome		= 0;
	
	private $_htmlContent 	= null;
	

	
	
	  
	function __construct() 
	{

	
    	/*
    	 * Einstellungen laden von der jPhone Komponente
    	 */
		$this->params = &JComponentHelper::getParams( 'com_jphone' );

		
	}
	
	
	
	
	
	/*
	 *	Seite als Homeseite setzen
	 */
	public function setHome()
	{

	
		$this->setHome = 1;

		
	}
	

	
	
	
	/*
	 *	Schnitstelle zum hinzufügen von Inhalten und aufruf der Funktionen
	 */
	public function addContent($dataArray) 
	{
	
	
		$func = '_'.$dataArray[0];
		
		$this->$func($dataArray);

		
	}
	
	
	
	
	
	/*
	 *	Fertige Seite anzeigen
	 */
	public function display()
	{
	
	
		/*
		 * Überprüfen ob es sich um die Startseite handelt und
		 * dann entweder mit oder ohne Template rendern
		 */
		if($this->setHome == 0){
		
			echo $this->_htmlContent;
	
		} else {
			
			echo $this->_getHtml();
		
		}

		
	}
	
	
	
	
	
	/*
	 *	Anzeige von Daten in der Listenansicht
	 */
	private function _list($dataArray)
	{
	
	
		$divId 		= $dataArray[1];
		$data 		= $dataArray[2];
		$tbFront	= $dataArray[3];
		
		
		$move = ( $this->params->get( 'move' ) ) 
				? 
					'class="' . $this->params->get( 'move' ) . '"' 
				: 
					'';
		
				
		$menu .= '<div id="' . $divId . '">';
		
		$menu .= $this->_toolbar( $this->params->get( 'homeTitle' ), $tbFront );
		
		$menu .= '<ul class="' . $this->params->get( 'menuStyle' ) . '">';
		
		
		
		foreach($data as $row) 
		{

			
			$menu .= '<li class="arrow">';
			
			$menu .= '<a ' . $move . ' href="' .  $row['link'] . '">' . $this->substrText($row['name'], 25) . '</a>';
			
			$menu .= '</li>';

			
		}

		
		$menu .= '</ul>';
		
		$menu .= $this->_getFooterModule();
		
		$menu .= '</div>';
	
		
		$this->_htmlContent .= $menu;
			
		
	}
	
	
	
	
	
	/*
	 *	Anzeigen einer Liste
	 */
	private function _blog($dataArray)
	{
	
	
		$divId 		= $dataArray[1];
		
		$data 		= $dataArray[2];
		
		$tbFront	= $dataArray[3];
		
		
		$move = ( $this->params->get( 'move' ) ) ? 'class="' . $this->params->get('move') . '"' : '';
	
		
		$blog .= '<div id="' . $divId . '">';

		$blog .= $this->_toolbar( $this->params->get( 'homeTitle' ), $tbFront );
		
		
		foreach($data as $row)
		{
		
		
			$blog .= '<ul class="'.$this->params->get('menuStyle').'">';
			
			$blog .= '<li class="arrow">';
			
			$blog .= '<a ' . $move . ' href="' . $this->baseUrl . 'index.php?option=com_jphone&view=content&id=' . $row['id'] . '">' . $this->substrText($row['name'], 25) . '</a>';
			
			$blog .= '</li>';
			
			$blog .= '<li>';
			
			$blog .= '<a ' . $move . ' href="' . $this->baseUrl . 'index.php?option=com_jphone&view=content&id=' . $row['id'] . '">';
			
			$blog .= '<textarea placeholder="Textarea" style="font-size:14px; margin:5px; height: 100%">' . strip_tags( $row[ 'introtext' ] ) . '</textarea>';
			
			$blog .= '</a>';
			
			$blog .= '</li>';
			
			$blog .= '</ul>';
		
		
		}
		
		$blog .= $this->_getFooterModule();
		
		$blog .= '</div>'; 
		
		$this->_htmlContent .= $blog;
		
		
	}
	
	
	
	
	
	/*
	 *	Anzeigen eines Content
	 */
	private function _content($dataArray)
	{
	
	
		$divId 		= $dataArray[1];
		
		$data 		= $dataArray[2];
		
		$tbFront	= $dataArray[3];
		
		
		$content .= '<div id="' . $divId . '">';
		
		$content .= $this->_toolbar( $this->params->get( 'homeTitle' ), $tbFront );
		
		$content .= $data;
		
		$content .= $this->_getFooterModule();
		
		$content .= '</div>';
		
		
		$this->_htmlContent .= $content;
		
		
	}
	
	
	
	
	
	/*
	 *	Anezeigen einer Toolbar
	 */
	private function _toolbar($titel, $back = TRUE) 
	{
	
	
		$html =  '<div class="toolbar">';
		
		$html .= '<h1>' . $this->substrText( $titel, 15 ) . '</h1>';
		
		
		if($back) 
		{
		
			$html .= '<a class="back" href="#">' . JText::_( 'JP BACK' ) . '</a>';
			
		}
		
		
		$html .= $this->menuButton;
		
		$html .= $this->_toolbarButton;
		
		$html .= '</div>';
		
		
		if($this->params->get('viewLogo') == 1) 
		{
		
			$html .= '<img src="components/com_jphone/lib/templates/' . $this->params->get( 'template' ). '/img/logo.jpg" border="0" width="100%" />';
		
		}
		
		
		return $html;
		
		
	}
	

	
	
	
	/*
	 *	Anezeigen einer Toolbar
	 */
	private function _addToolbarMenu($dataArray) 
	{
	
	
		$divId 		= $dataArray[1];
		
		$data 		= $dataArray[2];
		
		$tbFront	= $dataArray[3];
		
		
		$move = ( $this->params->get( 'move' ) ) 
				? 
					'class="' . $this->params->get( 'move' ) . '"' 
				: 
					'';
	
		
		$menu .= '<div id="' . $divId . '">';
		
		$menu .= '<ul class="' . $this->params->get( 'menuStyle' ) . '">';
		
		
		foreach($data as $row)
		{
		
			$menu .= '<li class="arrow">';
			
			$menu .= '<a ' . $move . ' href="' . $this->baseUrl . $row['link'] . '">' . $this->substrText($row['name'], 25) . '</a>';
			
			$menu .= '</li>';
			
		}
		
		
		$menu .= '</ul>';
		
		$menu .= '<a class="grayButton goback" href="#">'.JText::_( 'CLOSE' ).'</a>';
		
		$menu .= '</div>';
		
		
		$this->menuButton = '<a class="button slideup" href="#'.$divId.'">' . JText::_( $title ) . '</a>';
		
		
		$this->_htmlContent .= $menu;

		
	}
	
	
	
	
	
	/*
	 * Erzeuge das HTML-Template
	 */
	private function _getHtml()
	{
	
	
		$doc = &JFactory::getDocument();
		
		$lang = $doc->getLanguage();
		
		
		$html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
		
		$html .= "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$lang."\" lang=\"".$lang."\" >\n";
		
		$html .= "<head>\n";
		
		$html .= "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" /> \n";
		
		$html .= "<meta name=\"robots\" content=\"index, follow\" />\n"; 
		
		$html .= "<meta name=\"keywords\" content=\"".$this->params->get('METAKEYS')."\" /> \n";
		
		$html .= "<meta name=\"description\" content=\"".$this->params->get('METADESC')."\" /> \n";
		
		$html .= "<meta name=\"generator\" content=\"Joomla! 1.5 - Open Source Content Management\" /> \n";
		
		$html .= "<title>".$this->params->get('title')."</title> \n";
		
		$html .= "<link rel=\"stylesheet\" href=\"components/com_jphone/lib/jqtouch/jqtouch.min.css\" type=\"text/css\" media=\"screen\"  /> \n";
		
		$html .= "<link rel=\"stylesheet\" href=\"components/com_jphone/lib/templates/".$this->params->get( 'template' )."/css/theme.min.css\" type=\"text/css\" media=\"screen\"  />\n"; 
		
		$html .= "<script type=\"text/javascript\" src=\"components/com_jphone/lib/jqtouch/jquery.1.3.2.min.js\"></script> \n";
		
		$html .= "<script type=\"text/javascript\" src=\"components/com_jphone/lib/jqtouch/jqtouch.min.js\"></script> \n";
		
		$html .= $this->_getJqtouchJavascript();
		
		$html .= "</head>\n";
		
		$html .= "<body>\n";
		
		$html .= $this->_htmlContent;
		
		$html .= "</body></html>\n";
		
		
		return $html;
		
		
	}
	
	
	
	

	/*
	 * Funktion zum einfügen von HTML nach dem Content
	 */
	private function _getFooterModule(){
		$html .= $this->_getFullsite();
		$html .= "<div style=\"font-size: 12px;\"><center>";
		$html .= "Copyright &copy; 2010 ";
		$html .= "<a href=\"http://www.4you-studio.com\" target=\"_blank\">4you-studio.com</a>";
		$html .= ". Tous droits réservés.<br>";
		$html .= "Construit avec <a href=\"http://www.joomla.org\" target=\"_blank\">Joomla</a> et <a href=\"http://www.jqtouch.com\" target=\"_blank\">jQTouch</a>";
		$html .= "<center><br></div>";
		return $html;
	}
	
	
	
	
	
	/*
	 * Erzeugen des Javascript-Codes fï¿½r das Template
	 */
	private function _getJqtouchJavascript() 
	{
	
	
		$javascript = "<script type=\"text/javascript\" charset=\"utf-8\">";
	
        $javascript .= "var jQT = new $.jQTouch({\n";
        
        $javascript .= "icon: 'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/jqtouch.png',\n";
        
        $javascript .= "addGlossToIcon: false,\n";
        
        $javascript .= "startupScreen: 'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/jqt_startup.png',\n";
        
        $javascript .= "statusBar: 'black',\n";
        
        $javascript .= "preloadImages: [\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/logo.jpg',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/back_button.png',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/back_button_clicked.png',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/button_clicked.png',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/grayButton.png',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/whiteButton.png',\n";
        
        $javascript .= "'components/com_jphone/lib/templates/" . $this->params->get( 'template' ) . "/img/loading.gif'\n";
        
        $javascript .= "]\n";
        
        $javascript .= "});";
        
        $javascript .= "</script>";
	
        
        return $javascript;
        
        
	}
	
	
	
	
	// Fügt einen Toggel ein um auf die volle Webseite umzuschalten
	private function _getFullsite()
	{
		if($this->params->get('full_website') == 1) 
		{
			$html .= '<ul class="' . $this->params->get( 'menuStyle' ) . '"> ';
			$html .= '<li><center><a href="./index.php?mv=off" target="_webapp">' . JText::_( 'FULLSITE' ) . '</a></center></li>';
			$html .= '</ul>';
		}
		
		return $html;
	}
	
	
	
	
	
	//Kürzt Strings auf die vorgegeben Länge
	private function substrText($string, $count) 
	{
		if($this->params->get('cut_title') == 1)
		{
			if(strlen($string) > $count) 
			{
				$string = substr($string, 0, $count).'...';
			}
		}
		
		return $string;
		
		
	}
	
	
	
}




?>